-- ############################
--
-- >> Schweizer Bank (Mod)
-- >> Farming Simulator 17
--
-- @author Gunnar Lesser
-- @date 18/11/2016
-- @version 1.3
--
-- ############################


SwissBank = {};
SwissBank.dir = g_currentModDirectory;
SwissBank.hud = true;
addModEventListener(SwissBank);

-- Default Functions
function SwissBank:loadMap(name)
	SwissBank:logline();
	print("[SwissBank] -> Inititialize Version 1.3");
	SwissBank:init();

	-- Show all Options in Log File
	-- DebugUtil.printTableRecursively(g_currentMission,".",0,1);
	-- DebugUtil.printTableRecursively(g_careerScreen,".",0,2);

	SwissBank:logline();
end

function SwissBank:deleteMap()
	-- Singleplayer exit
	if g_currentMission:getIsServer() then
		SwissBank.hud = false;
	-- Multiplayer Disconnect / leave
	else
		SwissBank.hud = false;
		SwissBank.updateStorage();
	end
end

function SwissBank:keyEvent(unicode, sym, modifier, isDown)
	-- print("SwissBank Key Event:");
	-- print("Unicode: " .. unicode .. " // sym: " .. sym .. " //  modifier: " .. modifier .. " // isDown: " .. tostring(isDown));
	if SwissBank.run then
		-- print("Buchung noch in Arbeit!");
		return 0;
	end
	-- Abheben von Bank
	-- if sym == 270 and modifier == 1 and isDown == true then -- Numpad -
	if sym == 99 and modifier == 1 and isDown == true then
		SwissBank.run = true;
		-- print("Bankkonto vorher: " .. SwissBank.bankMoney);
		SwissBank.withdraw(10000);
	end
	-- Einzahlen in Bank
	-- if sym == 269 and modifier == 1 and isDown == true then
	if sym == 118 and modifier == 1 and isDown == true then
		SwissBank.run = true;
		-- print("Bankkonto vorher: " .. SwissBank.bankMoney);
		SwissBank.deposit(10000);
	end
	-- Betrag auf Bank anzeigen HUD
	-- if sym == 271 and modifier == 1 and isDown == true then
	if sym == 98 and modifier == 1 and isDown == true then
		-- SwissBank:showMoney();
		if SwissBank.hud == false then
			SwissBank.hud = true;
		else
			SwissBank.hud = false;
		end
	end
end

function SwissBank:mouseEvent(posX, posY, isDown, isUp, button)
end

function SwissBank:update(dt)
end

function SwissBank:draw()
	if SwissBank.hud then
		setTextColor(1.0, 1.0, 1.0, 1.0);
		SwissBank.overlay:render();
		renderText(0.84, 0.62, 0.02,tostring(SwissBank.bankMoney) .. ",- " .. g_i18n:getText("UNIT"));
		setTextColor(1.0, 1.0, 1.0, 1.0);
	end
end

-- Appended Event for Missionsave
function SwissBank:onMissionSave()
	-- Singleplayer
	if g_currentMission:getIsServer() then
		SwissBank.updateStorage();
	else
	-- Multiplayer
		if g_currentMission.isMasterUser then
			SwissBank.updateStorage();
		end
	end
end

function SwissBank:register()
	print("SwissBank register...");
end

-- Custom Functions

-- Create a line in the console
function SwissBank.logline()
	print("[SwissBank] ---------------------------------------------");
end

-- Add Money to mission from storage
function SwissBank.withdraw(money)
	-- Update Values
	SwissBank:getMissionValues();
	-- get difference
	local restValue = SwissBank.bankMoney - money;
	-- print("Storagedifferenz: " .. restValue);
	if restValue < 0 then
		print("Nicht genuegend Geld zum abheben");
		SwissBank.run = false;
		return 0;
	else
		-- Singleplayer
		if g_currentMission:getIsServer() then
			--SwissBank.updateStorage(-money);
			SwissBank.bankMoney = restValue;
			g_currentMission:addSharedMoney(money, "other");
			--g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_OK, "Schweizer Bank: 10000 abgehoben");
			SwissBank.run = false;
		else
		-- Multiplayer
			if g_currentMission.isMasterUser then
				--SwissBank.updateStorage(-money);
				SwissBank.bankMoney = restValue;
				g_client:getServerConnection():sendEvent(CheatMoneyEvent:new(money));
				--g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_OK, "Schweizer Bank: 10000 abgehoben");
				SwissBank.run = false;
			else
				g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_OK, g_i18n:getText("NO_PERMISSION"));
				SwissBank.run = false;
			end
		end
	end
end

-- Sub Money from mission to storage
function SwissBank.deposit(money)
	-- Update Values
	SwissBank:getMissionValues();
	-- get difference
	local restValue = SwissBank.missionMoney - money;
	-- print("Missionsgeld " .. SwissBank.missionMoney .. " - 10000: " .. restValue);
	if restValue < 0 then
		print("Nicht genuegend Geld zum einzahlen");
		SwissBank.run = false;
		return 0;
	else
		-- Singleplayer
		if g_currentMission:getIsServer() then
			--SwissBank.updateStorage(money);
			SwissBank.bankMoney = SwissBank.bankMoney + money;
			g_currentMission:addSharedMoney(-money, "other");
			--g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_OK, "Schweizer Bank: 10000 eingezahlt");
			SwissBank.run = false;
		else
		-- Multiplayer
			if g_currentMission.isMasterUser then
				--SwissBank.updateStorage(money);
				SwissBank.bankMoney = SwissBank.bankMoney + money;
				g_client:getServerConnection():sendEvent(CheatMoneyEvent:new(-money));
				--g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_OK, "Schweizer Bank: 10000 eingezahlt");
				SwissBank.run = false;
			else
				g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_OK, g_i18n:getText("NO_PERMISSION"));
				SwissBank.run = false;
			end
		end
	end
end

-- show money on bank
function SwissBank.showMoney()
	--g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_OK, "Kontostand der Schweizerbank: " .. SwissBank.bankMoney);
end

-- Initialize Variables
function SwissBank.init()
	-- Money from mission
	SwissBank.missionMoney = g_currentMission:getTotalMoney();
	-- Money from bank
	SwissBank.bankMoney = nil;
	-- Storage Path go one step back from "farmingSimulator2017/mods/blabla.zip" what means remove last charakters from path string /mods/ => 6
	SwissBank.storagepath = getUserProfileAppPath() .. "/swissBank.xml";
	-- Storage XML file
	SwissBank.xmlfile = nil;
	-- Load Storage File Values
	SwissBank:initStorage();
	-- Process is active or not
	SwissBank.run = false;
	-- Overlay
	SwissBank.overlay = Overlay:new(nil,  SwissBank.dir .. "menu.dds",0.78,0.30,0.20,0.36);
	-- Cash till Save
	SwissBank.cache = SwissBank.missionMoney;
	-- Mission Save Event
	-- Singleplayer Catch Save Event
	if g_currentMission:getIsServer() then
		g_careerScreen.saveSavegame = Utils.appendedFunction(g_careerScreen.saveSavegame, SwissBank.onMissionSave);
		g_careerScreen.saveSavegame = Utils.prependedFunction(CareerScreen.saveSavegame, SwissBank.onMissionSave);
	else
	-- Multiplayer Catch Save Event
		InGameMenu.saveCurrentGame = Utils.appendedFunction(InGameMenu.saveCurrentGame, SwissBank.onMissionSave);
	end
end

-- Init Storage
function SwissBank.initStorage()
	-- Only Local Storage File (Not Server)
	--if g_dedicatedServerInfo == nil then
	local startMoney = "xE";
	if SwissBank.checkStorage() then
		-- print("Wert aus XML laden");
		-- Load File
		SwissBank.xmlfile = loadXMLFile("swissBankXml",SwissBank.storagepath,"swissBank");
		-- Get Attribute
		SwissBank.bankMoney = getXMLString(SwissBank.xmlfile,"swissBank.balance");
		-- decode
		SwissBank.bankMoney = SwissBank.decodeNumber(SwissBank.bankMoney);
		-- print("Wert aus xml (SwissBank.bankMoney gesetzt mit Wert) : " .. SwissBank.bankMoney);
	else
		-- print("[Swiss Bank] -> Create storage file");
		-- Ceate File
		SwissBank.xmlfile = createXMLFile("swissBankXml",SwissBank.storagepath, "swissBank");
		-- Add Attributes (default 0)
		setXMLString(SwissBank.xmlfile,"swissBank.balance",startMoney);
		-- Save File
		saveXMLFile(SwissBank.xmlfile);
		-- Init Money Variable
		SwissBank.bankMoney = SwissBank.decodeNumber(startMoney);
	end
	--end
end

-- Update Mission Values
function SwissBank.getMissionValues()
	SwissBank.missionMoney = g_currentMission:getTotalMoney();
end

-- check storagefile
function SwissBank.checkStorage()
	if fileExists(SwissBank.storagepath) then
		return true;
	else
		return false;
	end
end

-- Update Storage
function SwissBank.updateStorage()
	-- temp variable
	local newBalance = SwissBank.bankMoney;
	-- get value from file (actually)
	-- SwissBank:initStorage();
	-- calculate new value
	-- newBalance = SwissBank.bankMoney; --+ value;
	-- print("Aktueller Betrag aus XML: " .. SwissBank.bankMoney .. " + Wert : " );--.. value);
	-- print("Zu speichern gilt : " .. SwissBank.bankMoney);
	-- Encode
	newBalance = SwissBank.encodeNumber(newBalance);
	-- set it in xml
	setXMLString(SwissBank.xmlfile,"swissBank.balance",newBalance);
	-- print("Gespeicherter Wert ist : " .. newBalance);
	-- print("Dateipfad ist: " .. SwissBank.storagepath);
	-- save xml
	saveXMLFile(SwissBank.xmlfile);
	-- init values
	SwissBank.initStorage();
	-- Say saved
	SwissBank:logline();
	print("[SwissBank] -> Saved!");
	SwissBank:logline();
	SwissBank.run = false;
end
-- decode number
function SwissBank.decodeNumber(code)
	local length = string.len(tostring(code));
	local char = "";
	local number = "";
	for i=1,length,2 do
		char = SwissBank.codierung(tostring(string.sub(code,i,i+1)));
		number = number .. char;
	end
	return tonumber(number);
end

-- encode number
function SwissBank.encodeNumber(number)
	local length = string.len(tostring(number));
	local char = "";
	local code = "";
	for i=1,length do
		char = SwissBank.codierung(tonumber(string.sub(number,i,i)));
		code = code .. char;
	end
	return tostring(code);
end

-- library code
function SwissBank.codierung(char)
	if char==0 then return "xE"; end
	if char==1 then return "dE"; end
	if char==2 then return "gQ"; end
	if char==3 then return "FO"; end
	if char==4 then return "Tm"; end
	if char==5 then return "OA"; end
	if char==6 then return "iR"; end
	if char==7 then return "dL"; end
	if char==8 then return "zx"; end
	if char==9 then return "bU"; end
	if char=="OA" then return 5; end
	if char=="zx" then return 8; end
	if char=="dE" then return 1; end
	if char=="bU" then return 9; end
	if char=="FO" then return 3; end
	if char=="dL" then return 7; end
	if char=="xE" then return 0; end
	if char=="gQ" then return 2; end
	if char=="Tm" then return 4; end
	if char=="iR" then return 6; end
	return 0;
end
